/*
 * Copyright (C) 2013 by I.Kato @ BS21 Lab
 * BS21 Lab library for Arduino
 *    ver.1.00 (14/aug/2013)
 *
 * This file is free software; you can redistribute it and/or modify it
 * under the terms of either the GNU General Public License version 2
 * or the GNU Lesser General Public License version 2.1,
 * both as published by the Free Software Foundation.
 */

#ifndef __BS21LABLIB_CPP__
#define __BS21LABLIB_CPP__


#include "Arduino.h"

#include <BS21LabLib.h>


///////////////////////////////////////////////////////////////
// O[o֐

// R[hϊT[rX֐
// Ch(UTF-16)ɑΉ񑀍֐݂Ȃ̂ŁÃT[rX֐ɂāA
// Ch񂩂ʏ̕(UTF-8)ɕϊĂA񑀍삷Ɨǂł傤B
// buffer ́Aϊ UTF-8 i[̂ɏ\ȃTCYłKv܂B UTF-16 ̑oCg1.5{{ڈłB
// ӁFobt@ӂ̃`FbN͂Ă܂̂ŁAӂĂB

// UTF-16  UTF-8 ϊTu֐
// Arduino IDE ł wchar_t t int16 Ȃ̂ŁAr̔ȑׂ̈ uint16_t őpĂ܂
static char * convertWCharToChar_subFunc (char * ptr, uint16_t wch, uint16_t wchHi)
{
  if (wch <= 0x007F) { // ASCII ͈̔
    // PoCgR[h
    *ptr++ = (char)wch; // 0x00`0x7F
  } else if (wch <= 0x07FF) { // U+0080`U+07FF: MVA()L(^_`)Ȃ
    // QoCgR[h
    *ptr++ = (char)(0xC0 + ((uint8_t)(wch >> 6) & 0x1F)); // 0xC2`0xDF
    *ptr++ = (char)(0x80 + ((uint8_t) wch       & 0x3F)); // 0x80`0xBF
  } else if ((wch >= 0xD800) && (wch <= 0xDBFF)) { // U+D800`U+DBFF: 𕄍 int16 ŔrׁAwch  uint16_t ɂĂ܂
    ; // TQ[gyÂP[hڂ͉̎܂
  } else if ((wch >= 0xDC00) && (wch <= 0xDFFF)) { // U+DC00`U+DFFF: 𕄍 int16 ŔrׁAwch  uint16_t ɂĂ܂
    // TQ[gyÂQ[hڂ̎AP[hڂƍ킹ď܂
    // ܂ATQ[gyA UTF-32 𐶐܂BU+10000`U+10FFFF ͈̔͂ɂȂ悤ɂ܂
    uint32_t utf32 = 0x10000uL + ((uint32_t)(wchHi & 0x03FF) << 10) + (wch & 0x03FF);
    // SoCgR[h
    *ptr++ = (char)(0xF0 + ((uint8_t)(utf32 >> 18) & 0x07)); // 0xF0`0xF7
    *ptr++ = (char)(0x80 + ((uint8_t)(utf32 >> 12) & 0x3F)); // 0x80`0xBF
    *ptr++ = (char)(0x80 + ((uint8_t)(utf32 >>  6) & 0x3F)); // 0x80`0xBF
    *ptr++ = (char)(0x80 + ((uint8_t) utf32        & 0x3F)); // 0x80`0xBF
  } else {
    // RoCgR[h
    *ptr++ = (char)(0xE0 + ((uint8_t)(wch >> 12) & 0x0F)); // 0xE0`0xEF
    *ptr++ = (char)(0x80 + ((uint8_t)(wch >>  6) & 0x3F)); // 0x80`0xBF
    *ptr++ = (char)(0x80 + ((uint8_t) wch        & 0x3F)); // 0x80`0xBF
  }
  return ptr; // XV|C^Ԃ
}

// SRAM  UTF-16  UTF-8 ɕϊ܂
size_t convertWCharToChar (char * buffer, const wchar_t * wstr)
{
  char * ptr = buffer; // Ɨp|C^

  wchar_t wch, wchHi = 0;
  while (1) {
    wch = *wstr; // SRAM  UTF-16 o
    if (wch == L'\0') { // ̏I
      break;
    }
    wstr++;

    ptr = convertWCharToChar_subFunc (ptr, (uint16_t)wch, (uint16_t)wchHi); // Tu֐Ăяo

    wchHi = wch; // POɃRs[(TQ[gyAp)
  }
  *ptr = '\0'; // I[ NUL 

  return (size_t)(ptr - buffer); // ϊoCgԂ
}

// vO UTF-16  UTF-8 ɕϊ܂
size_t convertWCharToChar_P (char * buffer, const prog_wchar * pwstr)
{
  char * ptr = buffer; // Ɨp|C^

  wchar_t wch, wchHi = 0;
  while (1) {
    wch = (wchar_t)pgm_read_word (pwstr); // vO UTF-16 o
    if (wch == L'\0') { // ̏I
      break;
    }
    pwstr++;

    ptr = convertWCharToChar_subFunc (ptr, (uint16_t)wch, (uint16_t)wchHi); // Tu֐Ăяo

    wchHi = wch; // POɃRs[(TQ[gyAp)
  }
  *ptr = '\0'; // I[ NUL 

  return (size_t)(ptr - buffer); // ϊoCgԂ
}

#endif // __BS21LABLIB_CPP__

